#ifndef gui_h
#define gui_h

#include <iostream>
#include "../comunicaciones/comunicaciones.h"
#include "../ajedrez/ajedrez.h"

using namespace comunicaciones;
using namespace ajedrez;

namespace GUI
{
	// Interfaz I_gui	
	class I_gui
	{
	public:
		virtual void on_destino(int x_dest, int y_dest) = 0;
		virtual void on_origen(int x_orig, int y_orig) = 0;
		virtual void on_consejo() = 0;
	};

	// Implementa interfaz I_observer
	class Gui : public comunicaciones::I_observer
	{
	private:
		Tablero& tablero_agr;
	public:	
		Gui(Tablero& tablero);
		void notifica_mensaje(const string& mensaje);
		void dibuja_tablero();
		void dibuja_marcador();
		void dibuja_interfaz();
		void alerta();
	};
}

#endif