#include "cpu.h"

using namespace std;

// Destructor ALU
ALU::~ALU()
{
	cout << "Destruyendo ALU: " << unidad << endl;
}

void UC::set_ALUS(ALU* alu1, ALU* alu2)
{
	alus[0] = alu1;
	alus[1] = alu2;
}

void UC::imprime_tipo_ALU()
{
	std::cout << alus[0]->unidad << std::endl;
	std::cout << alus[1]->unidad << std::endl;
}

// Destructor Unidad de Control
UC::~UC()
{
	cout << "Destruyendo UC" << endl;
}

// Destructor de registros
Registro::~Registro()
{
	cout << "Destruyendo registro: " << tipo << endl;
}

CPU::CPU()
{
	uc = new UC();

	Registro* reg = new Registro();
	reg->tipo = "PG 1";
	lista_regs.push_back(reg);

	reg = new Registro();
	reg->tipo = "PG 2";
	lista_regs.push_back(reg);

	alus[0] = new ALU();
	alus[0]->unidad = "Suma";

	alus[1] = new ALU();
	alus[1]->unidad = "Resta";

	// Pasa referencias
	uc->set_ALUS(alus[0], alus[1]);
	uc->imprime_tipo_ALU();
	
}

// Elimina composiciones
void CPU::destruye_componentes()
{
	delete uc;

	delete alus[0];
	delete alus[1];

	vector<Registro*>::iterator it;
	
	for (it = lista_regs.begin(); it != lista_regs.end(); it++)
		delete *it;


}

// Destructor CPU
CPU::~CPU()
{
	destruye_componentes();
}

int main() 
{
	
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	
	CPU* cpu = new CPU();

	delete cpu;

	cin.get();
	
	return 0;
}