#include "libreria.h"

using namespace std;

void Libro::set_datos(const string& autor)
{
	this->autor = autor;
}

string Libro::get_autor()
{
	return autor;
}

void Libreria::add_libro(int isbn, const string& autor)
{
	Libro* libro = new Libro();
	libro->set_datos(autor);
	biblioteca[isbn] = libro;
}

string Libreria::get_libro(int isbn)
{
	Libro* libro = biblioteca[isbn];
	return libro->get_autor();
}

void Libreria::borra_libros()
{
	map<int, Libro*>::iterator it;
	
	for (it = biblioteca.begin(); it != biblioteca.end(); it++)
		delete (*it).second;
	cout << "Borrando libros" << endl;

}

Libreria::~Libreria()
{
	borra_libros();
}

int main()
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	
	Libreria lib;
	lib.add_libro(12345678, "Miguel de Cervantes");
	lib.add_libro(4567890, "Friedrich Hlderlin");
	cout << lib.get_libro(4567890) << endl;
	cin.get();
	return 0;
}